<template>
    <input type="text"
           v-bind:value="formattedDate"
           v-on:input="$emit('input', $event.target.value)"
           readonly="readonly"
           placeholder="YYYY-MM-DD"/>
</template>

<script type="text/ecmascript-6">
    import moment from "moment";

    export default {
        name: "EnglishDatePicker",

        props: {
            type: {default: "day"},
            value: {default: ""},
            uniqueid: {
                type: String,
                default: "",
            },
        },

        data() {
            return {
                date: this.value,
                config: {
                    day: {
                        dateFormat: "yy-mm-dd",
                        changeMonth: true,
                        changeYear: true,
                        yearRange: "-100:+0",
                        beforeShow: (input, inst) => {
                            inst.dpDiv.removeClass("datepicker-month-year");
                        },
                        onClose: this.onCloseDayPicker,
                    },
                },
            };
        },

        computed: {
            formattedDate() {
                if (this.date.length < 1) {
                    return this.date;
                }

                return moment(this.date).format("YYYY-MM-DD");
            },
        },

        watch: {
            // when the value for the input is changed from the parent,
            // the value prop will update, and we pass that updated value to the plugin.
            value: {
                handler: function(newVal) {
                    $(this.el).datepicker("setDate", newVal);
                    this.fireEvent(newVal)
                },
                immediate: true,
            },
        },

        mounted: function() {
            // activate the plugin when the component is mounted.
            window.Bus.$on("bsDate", this.updateDateFromEvent);

            $(this.$el).datepicker(this.config[this.type]);
        },

        methods: {
            onCloseDayPicker(date) {
                this.$emit("input", date);
                this.fireEvent(date);
            },

            fireEvent(date) {
                window.Bus.$emit("adDate", {"date": date, "uniqueid": this.uniqueid, "type": this.type});
            },

            updateDateFromEvent(data) {
                if (data.uniqueid === this.uniqueid) {
                    this.date = data.adDate;
                    this.$emit("input", moment(this.date).format("YYYY-MM-DD"));
                }
            },
        },
    };
</script>

<style scoped>

</style>
